\\ $Id: generators.gp,v 1.1.1.1 2006/08/10 17:33:43 kb Exp $
global(globalU, globalD, globalK, globalinvK, globalT);
install(reducemodlll, "GG");

\\ (Gen from relations()) * K = g = initial generators for K2 OF (not SNF)
\\ invK = K^(-1)
\\ K2 OF = Z^g / Im A;  D = UAV, D diagonal, G = g U^(-1) SNF generators

\\ nicegen() modifies final generators G --> G' = G * T

/************ GENERIC ****************/
global(MODPR);

initame(v)=
{
  d = bnf.disc; p = v.p;
  MODPR = nfmodprinit(bnf,v);0;
}

red(e) = nfeltreducemodpr(bnf,e,MODPR);
/************ END GENERIC ************/

\\ s = { a, b }
tame(s, v)=
{ my(e,va,vb, a = s[1], b = s[2]);

  va = nfeltval(bnf,a,v);
  vb = nfeltval(bnf,b,v);
  e = nfeltdiv(bnf,
    nfeltpow(bnf,a, vb),
    nfeltpow(bnf,b, va)
  );
  if (va%2 && vb%2, -e, e);
}

\\ Express {x,y} in K2 F on the generators for K2 OF (may have a denominator)
\\ If y omitted, assume input is symbol(x,y)
\\ Error if input is not a S-unit for S = list of "bad primes" in relations().
symbolisprincipal(x, y)=
{ my(i,v,v1,v2,w,den);

  v = if (y, 
    symbol(x,y)
  , 
    if (type(x) == "t_MAT", Symbol(x), x));
  v = vecextract(v, globalperm);
  v1= v[1..#matwedge];
  v2= v[#matwedge+1..#v];
  v = v1 - globalB*v2; \\ {x,y} expressed on Gen
  \\ w expressed on the generators output by generators() [ G ]
  w = globalU * (globalinvK * v);
  den = denominator(w); w *= den;

  \\ w expressed on modified generators from nicegen() [ G * T ]
  w = globalT^(-1) * w[1..#globalD];
  [den, vectorv(#globalD, i, w[i] % globalD[i])];
}

\\ pick up non trivial generator. K_2^S = < Gen >
get_Gen()=
{ my(l, Gen, a = 0, lWall = #Wall);
  
  Gen = vector( get_dim() );
  for(j = 1, lWall,
    for(k= j, lWall, Gen[a++] = [Wall[j], Wall[k]])
  );
  Gen = vecextract(Gen, globalperm)[1..#matwedge];
}

to_fact(g, e, ind) =
{ my(perm,i,k,l);

  l = #e;
  perm = vector(l);
  for (i=1, l,
    if  (e[i], perm[k++] = i)
  ); \\ indexes of needed generators
  perm = perm[1..k];
  g = vecextract(g, perm);
  e = vecextract(e, perm);
  Mat([g~, e]);
}

nicesymbol(a, b)=
{
  if (!b, b = a[2]; a = a[1]);
  if (type(a) != "t_COL", a = nfalgtobasis(bnf, a));
  if (type(b) != "t_COL", b = nfalgtobasis(bnf, b));
  a = if (isscalar(a), a[1], nfbasistoalg(bnf,a));
  b = if (isscalar(b), b[1], nfbasistoalg(bnf,b));
  [a, b];
}

modvec(a, b) = vector(#a, i, a[i] % b[i]);

isscalar(a) = for (i=2, #a, if (a[i], return (0))); 1;

tryreplace(a, b, k)=
{ my(s,t, d);

  a = nfalgtobasis(bnf, a);
  b = nfalgtobasis(bnf, b);
  s = symbolisprincipal(a, b);
  d = s[1];
  t = s[2];
  if (gcd(globalD[k], t[k]) != 1 || modvec(t * globalD[k], globalD), return);
  \\ replacing G[k] by G * t ( = {a,b}^d ) yields the same SNF

  done = isscalar(a) || isscalar(b);
  if (!minden || done || s[1] < minden,
    minden = s[1]; tbest = t;
    notbad = Mat( [ nicesymbol(a, b), d ] )
  );
}

replacegen(k)=
{ local(T, i, j, notbad, minden, tbest, done);

  for (i=1, #Wall,
    for (j=i, #Wall,
      tryreplace(Wall[i], Wall[j], k);
      if (done, break(2))
    )
  );
  if (!minden,
    for (i=1, #Wall,
      for (j=1, #Wall,
        for (h=j, #Wall,
          tryreplace(Wall[i], Wall[j] * Wall[h], k);
          if (done, break(3))
        )
      )
    )
  );
  if (minden,
    T = matid(#globalD);
    T[,k] = tbest;
    globalT *= T;
  );
  notbad;
}

nicegen(fa)=
{ my(g);

  for (i=1, #fa,
    if ((g = replacegen(i)), fa[i] = g)
  ); fa;
}

refine_gen(A, raw)=
{ my(h,i,k,perm,fa,liftedGen,s,SNF);

  SNF = matsnf(A, 1);  globalU = SNF[1];
  SNF = matsnf(SNF,4); globalD = todiagonal(SNF[3]);
  globalT = matid(#globalD);

  h = prod(i=1, #globalD, globalD[i]);
  if (h == 1, return ([1,[],[]]));

  \\ coordinates of new generators: Gen * newGen
  my (Ui = (globalU^(-1))[,1..#globalD]);
  newGen = globalK * reducemodlll(Ui, A);
  newGen = reducemodlll(newGen, matwedge);
  l = matsize(newGen)[1];
  perm = vector(l);
  for (i=1, l, 
    if (newGen[i,], perm[k++] = i)
  ); \\ indexes of needed generators
  perm = perm[1..k];
  Gen = vecextract(Gen, perm);
  M2 = vecextract(newGen, perm, "..");
\\  check_Gen(Gen,M2);
  liftedGen = vector(#Gen, i, nicesymbol(Gen[i]));
  fa = vector(#M2, i, to_fact(liftedGen, M2[,i], i));
\\ [lift(Gen), vector(#M2,i,M2[,i])]
  [h, globalD, if (raw, fa, nicegen(fa)) ];
}

todiagonal(M) = vector(#M, i, M[i,i]);

\\ perm o (relation matrix) = ( matwedge  B )
\\                            (    0     Id )
generators(raw)=
{ my(l,lS,bid,v,orders,M);

  l = #matwedge; \\ # of generators left
  lS = #S;
  M = matrix(lS,l);
  orders = vectorv(lS);
  \\ generators for K_2^S F
  Gen = get_Gen();
  \\ compute generators for K_2 O_F, i.e coeffs a_i such that
  \\ d_v ( \sum a_i Gen[i] ) = 0 in (O_F/v)^* for all tame symbols d_v
  \\ the problem is linearized by choosing primitive roots
  for (i=1, lS,
    v = S[i]; initame(v);
    \\ compute mult. group (O_F / v)^*: cyclic, with generator g_v, say
    bid = idealstar(bnf, v);
    orders[i] = bid[2][1]; \\ group order = p^f - 1
    if (orders[i] == 1,
      M[i, ] = vector(l) \\ p = 2 and f = 1
    ,
      for(j=1, l,
        \\ express the tame symbol in terms of the generator g_v
        M[i, j] = ideallog(bnf, lift(tame(Gen[j], v)), bid) [1]
      )
    )
  );
  \\ K2 O_F = < Gen * K >
  globalK = matsolvemod(M, orders, 0,1)[2];
  globalinvK = globalK^(-1);
  
  \\ here K * A = Im(matwedge) \cap Im(K)
  \\ Im(K) / K * A ~ Z^l / A = K2 O_F, assuming matwedge includes all relators
  A = matkerint(concat(globalK, matwedge))[1..l,];
  if (raw == 2, A, refine_gen(A, raw));
}

/* CHECKS */

groupmul(g,M)=
{ my(v,i);

  for (i=1, #M,
    v = factorback(g, M[,i]);
    if (lift(lift(v)) != 1, error("not tame: ", [g, M[,i]]))
  );
}

\\ check that Gen * M are tame symbols
check_Gen(Gen,M) =
{ my(i,j,v);

  for (i=1, lS,
    v = S[i]; initame(v);
    groupmul(vector(#Gen,j, red(tame(Gen[j],v))), M)
  );
}
