\\ $Id: keune.gp,v 1.1.1.1 2006/08/10 17:33:43 kb Exp $

initkeune(pol,p) =
{ my(r, rinv, polE, fa);
  
  if (p == 2, bnfE = bnfinit(pol); return);

  g = znprimroot(p);
  compo = polcompositum(pol, polcyclo(p), 1)[1];
  polE = compo[1];
  alp = compo[2]; \\ F = Q(alp),  pol(alp) = 0
  z   = compo[3]; \\ = zeta_p
  lambda = compo[4]; \\ E = F(z) = Q(lambda alp + z)
 
  r = polredabs(polE, 17); \\ prevent polredabs from factoring forever
  nfE = nfinit(r[1]);
  alp = subst(alp.pol, x, r[2]);
  z   = subst(  z.pol, x, r[2]);
  SIGMA = lambda*alp + z^lift(g); \\ s(alp) = alp, s(z) = z^g

  rinv = modreverse(r[2]);
  SIGMA = subst(rinv.pol, x, SIGMA);

  bnfE = bnfinit(nfE);
  nfF = nfinit(pol); return;
}

\\ compute r_p( K2 O_Q(F)) ) according to Keune's formula
\\ output is [rank mu part, 1-eigenspace], r_p = rank + dimension eigenspace.
keune(pol,p) =
{ my(A, U, id, P, PE, rmu, r, t, inv, rel, gen, cyc);
\\  local(z, bnfE, g,SIGMA);
  initkeune(pol,p);

  /* Cl(1/p) / [p] */
  cyc = bnfE.cyc;
  rel = mathnfmodid(matdiagonal(cyc), p); \\ = relations for Cl / [p]
  PE = idealprimedec(bnfE, p);
  for (i=1, #PE,
    rel = concat(rel, bnfisprincipal(bnfE, PE[i],0))
  );
  A = matsnf(mathnf(rel), 1); \\ = Cl(1/p) / [p]
  U = A[1];
  cyc = matsnf(A[3], 4); r = #cyc;

  /* mu_p part */
  if (p == 2,
    rmu = bnfE.sign[1] + #PE - 1 + r;
  ,
    my(degE, degF, degEF);

    PF = idealprimedec(nfF, p);
    degF = poldegree(nfF.pol);
    degE = poldegree(nfE.pol);
    degEF = degE/degF; \\ relative degree
    if (degEF == 1,
      rmu = #PF - 1; \\ zeta_p in F
    ,
      for (i=1, #PF,
        P = PF[i]; t = P.gen[2]; \\ uniformizer
        t = lift(nfbasistoalg(nfF,t));
        id = idealhnf(nfE, p, subst(t,x,alp)); \\ = P O_E
        fa = idealfactor(nfE, id)[,2];
        if (#fa == degEF, rmu++); \\ totally split
      );
    );
  );

  /* Galois invariants */
  if (r && p > 2,
    my(app, Uinv = U^(-1));
    \\ (g) generators of Cl --> (g) Uinv generators of Cl(1/p) / [p]
    \\ X in Cl projects to U X in Cl(1/p) / [p]
    gen = vector(r, i, idealfactorback(bnfE, bnfE.gen, Uinv[,i]));

    app = vector(r, i, nfgaloisapply(bnfE, SIGMA, gen[i]));
    A   = vector(r, i, bnfisprincipal(bnfE,app[i], 0));
    A = U[1..r,] * Mat(A);
    inv = lift(matker(g*A - 1))
  ,
    inv = [;]
  );

\\PRINT("Cl(1/p)/[p] = " cyc);
\\PRINT("generators = " gen);
  PRINT([rmu, inv]);
  rmu + #inv;
}
